#/usr/bin/perl
<<DOC; 
Axel COURT & Marjorie SEIZOU
MARS 2010
 usage : perl extraction-xml.pl fichier_tagg fichier_motif
 
DOC

# Test des paramtres
if($#ARGV!=1){
	print "usage : perl $0 fichier_tagge fichier_motif\n";
	exit;
}

# Utilisation de la bibliothque perl XML::Path
use XML::XPath;

# Enregistrement des arguments dans des variables
my $tag_file = shift @ARGV;
my $patterns_file = shift @ARGV;

# Initialisations
my @patterns;
my $nb_patterns=0;
my $nb_tokens=0;
my %posreconnus;

######################
# Ouverture du fichier de patrons
open(PATTERNSFILE, $patterns_file) or die "Impossible d'ouvrir $patterns_file : $!\n";
# Lecture du fichier contenant les motifs, un motif par ligne (par exemple : NOM ADJ) => on stocke ces patrons dans un tableau
while ($ligne = <PATTERNSFILE>) {
	# On supprime avec la fonction chomp un ventuel retour  la ligne
	chomp($ligne);
	# 
	$nb_patterns = push(@patterns,$ligne);
}

# Cration de l'objet XML::XPath pour explorer le fichier fichier XML donn en argument
my $xp = XML::XPath->new( filename => $tag_file ) or die "Oups, impossible de gnrer l'objet XML::XPath : vrifiez la bonne formation de votre document XML !";

# Recherche des motifs dans le fichier XML donn en argument
foreach $pattern (@patterns) {
	# Construction au moyen de la fonction split d'un tableau dont chaque lment a pour valeur  un token du motif recherch
	@tokens = split(/ /,$pattern);
	$posreconnus{$pattern} = ();
	&extract_pattern(@tokens);
}

# Ecriture de la sortie
my $namefile =  $tag_file;
$namefile =~ s/(.+)(\.xml)/$1/;
my $match_file = "resultat_$namefile.txt";
# Ouverture de ce fichier frachement cr
open(MATCHFILE, ">:encoding(iso-8859-1)", "$match_file") or die "Impossible d'ouvrir $match_file : $!\n";
#-------------------------------------------------
# Impression des rsultats de l'extraction
#-------------------------------------------------
my $out = "";
#-------------------------------------------------
# Parcours de la table de hachage
while ( ($key, $value) = each(%posreconnus) ) {
	if ($value ne "") {
		$out .= "------------------------\n";
		$out .= "$key\n-------------------------\n";
		#--------------------------------------------------------------
		# Parcours du tableau contenant les suites de mots reconnues
		# qui correspondent au patron syntaxique (la cl)
		foreach my $term (@$value) {
			$out .= $term;
			$out .= "\n";
		#--------------------------------------------------------------
		}
		$out .= "\n\n\n";
	}
}
print MATCHFILE $out;
# Fermeture du fichier !
close(MATCHFILE);

# Routine d'extraction d'un motif
sub extract_pattern {
	@tokenz = @_;
	# La fonction shift coupe le premier lement d'un tableau et le revoie en rsultat
	$first_token = shift @tokenz;
	chomp($first_token);
	# Initialisation du chemin xpath correspondant au motif recherch
	# Pas d'effet de bord possible : le script principal de parcours des fils RSS ajoute un "point" de ponctuation finale aprs chaque titre et chaque rsum, s'il n'y
	# en a pas dj. Consquence : impossible d'extraire par exemple l'adjectif final d'un titre et le nom qui commence le rsum suivant
	$search_path = "//element/data[1][contains(text(),\"$first_token\")]";
	foreach my $token (@tokenz) { # Construction  recursive du chemin xpath correspondant au motif recherch
		chomp($token);
		$search_path .= "/ancestor::element/following-sibling::element[1]/data[1][contains(text(),\"$token\")]";
	}
	# Boucle sur les nuds reconnus du chemin xpath
	foreach my $noeud ( $xp->findnodes($search_path)->get_nodelist() ) {
		# Initialisation du tableau des formes => ne contient qu'un seul motif  la fois
		# On le fait ici pour des raisons videntes d'conomie de mmoire et donc de performance
		my @matching_tokens;
		# On remonte d'un cran au nud  parent pour extraire la forme trouve
		# Dans le cas d'un motif NOM ADJ, c'est la forme de l'adjectif qu'on atteint
		$noeud_tmp = $noeud -> getParentNode;
		$i = 0;
		foreach (@tokens) {
			$i++;
			# on rcupre la forme
			# noter que le "3" de getChildNode(3) correspond au "data[3]" de la feuille XSLT
			$motif = $noeud_tmp->getChildNode(3)->string_value;
			# unshift(@matching_tokens,$motif) ajoute au dbut du tableau @matching_tokens un lment dont la valeur est le contenu de la variable $motif (puisqu'on part de la fin du motif)
			$nb_tokens = unshift(@matching_tokens, $motif);
			$motif = "";
			# On remonte recursivement aux nuds prcedents pour extraire la forme
			# dans le cas d'un motif NOM PRP NOM, on rcupre ainsi PRP puis NOM (le premier)
			# Noter que "precding-sibling" est l'axe inverse de "following-sibling"
			@noeudtmp = $xp->findnodes("./preceding-sibling::element[1]",$noeud_tmp)->get_nodelist();
			$noeud_tmp = shift(@noeudtmp);
		}
		# criture des rsultats dans un fichier en utilisant la fonction join, pratique !
		push(@{$posreconnus{$pattern}}, join(' ', @matching_tokens));
	}
}